"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CheckboxField = exports.Checkbox = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _designparams = require("../designparams");

var _Typography = require("../Typography");

var _utils = require("../utils");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["checked", "label", "disabled", "onChange", "onCheckedValueChange", "onPartialValueChange", "onFocus", "onPointerUp", "onPointerDown", "partial", "className"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var BoxHalo = _styledComponents.default.div.withConfig({
  displayName: "Checkbox__BoxHalo",
  componentId: "sc-1pw2164-0"
})(["position:absolute;top:3px;left:3px;height:18px;width:18px;border-radius:", ";transition:transform 100ms;pointer-events:none;"], _designparams.shape.radius.small);

var Container = _styledComponents.default.div.withConfig({
  displayName: "Checkbox__Container",
  componentId: "sc-1pw2164-1"
})(["position:relative;cursor:pointer;display:inline-flex;align-items:center;justify-content:center;width:24px;height:24px;", " &:hover ", "{background-color:", ";transform:scale(1.77);}&:focus-within{outline:none;", "}&:active{", "}", ""], _ref => {
  var {
    disabled
  } = _ref;
  return disabled ? (0, _styledComponents.css)(["opacity:", ";pointer-events:none;"], _designparams.opacity[48]) : undefined;
}, BoxHalo, _ref2 => {
  var {
    checked,
    partial,
    theme
  } = _ref2;
  return checked || partial ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16]);
}, _ref3 => {
  var {
    visibleFocus,
    checked,
    partial,
    theme
  } = _ref3;
  return visibleFocus ? (0, _styledComponents.css)(["", "{background-color:", ";transform:scale(1.77);}", ",", ",", "{border:2px solid ", ";}"], BoxHalo, checked || partial ? theme.color.elementPrimary(_designparams.opacity[16]) : theme.color.element11(_designparams.opacity[16]), CSSBlankCheckbox, CSSCheckboxChecked, CSSCheckboxIndeterminate, theme.color.textPrimary()) : undefined;
}, _ref4 => {
  var {
    checked,
    partial,
    theme
  } = _ref4;
  return checked || partial ? (0, _styledComponents.css)(["", "{background-color:", ";transform:scale(1.88);}", ",", "{background-color:", ";}"], BoxHalo, theme.color.elementPrimary(_designparams.opacity[24]), CSSCheckboxChecked, CSSCheckboxIndeterminate, theme.color.textPrimary()) : (0, _styledComponents.css)(["", "{background-color:", ";transform:scale(1.88);}", "{border:2px solid ", ";}"], BoxHalo, theme.color.element11(_designparams.opacity[24]), CSSBlankCheckbox, theme.color.text02());
}, _ref5 => {
  var {
    hasLabel
  } = _ref5;
  return hasLabel ? (0, _styledComponents.css)(["width:100%;justify-content:flex-start;padding-left:3px;> span{margin-left:28px;}"]) : undefined;
});

var BoxNative = _styledComponents.default.input.withConfig({
  displayName: "Checkbox__BoxNative",
  componentId: "sc-1pw2164-2"
})(["position:absolute;top:0;left:0;cursor:pointer;display:unset;margin:0;padding:0;height:100%;width:100%;opacity:0;"]);

var BaseCheckbox = _styledComponents.default.div.withConfig({
  displayName: "Checkbox__BaseCheckbox",
  componentId: "sc-1pw2164-3"
})(["width:18px;height:18px;border-radius:", ";box-sizing:border-box;display:inline-flex;align-items:center;justify-content:center;pointer-events:none;position:absolute;"], _designparams.shape.radius.small);

var CSSCheckboxChecked = (0, _styledComponents.default)(BaseCheckbox).withConfig({
  displayName: "Checkbox__CSSCheckboxChecked",
  componentId: "sc-1pw2164-4"
})(["background-color:", ";::after{content:'';width:5px;height:10px;border:solid #fff;border-width:0 2px 2px 0;transform:rotate(45deg);margin-bottom:3px;}"], _ref6 => {
  var {
    theme
  } = _ref6;
  return theme.color.elementPrimary();
});
var CSSCheckboxIndeterminate = (0, _styledComponents.default)(BaseCheckbox).withConfig({
  displayName: "Checkbox__CSSCheckboxIndeterminate",
  componentId: "sc-1pw2164-5"
})(["background-color:", ";::after{content:'';width:10px;height:2px;background-color:#fff;border-radius:", ";}"], _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.elementPrimary();
}, _designparams.shape.radius.small);
var CSSBlankCheckbox = (0, _styledComponents.default)(BaseCheckbox).withConfig({
  displayName: "Checkbox__CSSBlankCheckbox",
  componentId: "sc-1pw2164-6"
})(["border:2px solid ", ";"], _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.element01();
});

var Checkbox = _ref9 => {
  var {
    checked,
    label,
    disabled = false,
    onChange,
    onCheckedValueChange,
    onPartialValueChange,
    onFocus,
    onPointerUp,
    onPointerDown,
    partial = false,
    className
  } = _ref9,
      props = _objectWithoutProperties(_ref9, _excluded);

  var {
    isPointerOn,
    isPointerOff,
    determineVisibleFocus,
    visibleFocus
  } = (0, _reactHooksShareable.useVisibleFocus)();
  var handleChange = (0, _react.useCallback)(e => {
    onChange === null || onChange === void 0 ? void 0 : onChange(e);

    if (partial) {
      if (onPartialValueChange !== undefined && onCheckedValueChange !== undefined) {
        onPartialValueChange(false);
        onCheckedValueChange(false);
      }
    } else if (onCheckedValueChange !== undefined) {
      onCheckedValueChange(e.target.checked);
    }
  }, [partial, onChange, onCheckedValueChange, onPartialValueChange]);
  var handleFocus = (0, _react.useCallback)(e => {
    onFocus === null || onFocus === void 0 ? void 0 : onFocus(e);
    determineVisibleFocus();
  }, [determineVisibleFocus, onFocus]);
  var handlePointerUp = (0, _react.useCallback)(e => {
    onPointerUp === null || onPointerUp === void 0 ? void 0 : onPointerUp(e);
    isPointerOff();
  }, [isPointerOff, onPointerUp]);
  var handlePointerDown = (0, _react.useCallback)(e => {
    onPointerDown === null || onPointerDown === void 0 ? void 0 : onPointerDown(e);
    isPointerOn();
  }, [isPointerOn, onPointerDown]);
  var CheckBoxIcon = (0, _react.useMemo)(() => {
    return partial ? /*#__PURE__*/(0, _jsxRuntime.jsx)(CSSCheckboxIndeterminate, {}) : checked ? /*#__PURE__*/(0, _jsxRuntime.jsx)(CSSCheckboxChecked, {}) : /*#__PURE__*/(0, _jsxRuntime.jsx)(CSSBlankCheckbox, {});
  }, [partial, checked]);
  var CheckboxLabel = (0, _react.useMemo)(() => {
    return label !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
      variant: "navigation-label",
      children: label
    }) : null;
  }, [label]);
  var hasLabel = label !== undefined;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(Container, {
    className: className,
    disabled: disabled,
    checked: checked,
    partial: partial,
    hasLabel: hasLabel,
    visibleFocus: visibleFocus,
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(BoxHalo, {}), CheckBoxIcon, CheckboxLabel, /*#__PURE__*/(0, _jsxRuntime.jsx)(BoxNative, _objectSpread(_objectSpread({
      type: "checkbox",
      checked: checked,
      disabled: disabled
    }, props), {}, {
      onChange: handleChange,
      onPointerDown: handlePointerDown,
      onPointerUp: handlePointerUp,
      onFocus: handleFocus
    }))]
  });
};

exports.Checkbox = Checkbox;
var CheckboxField = (0, _utils.withField)(Checkbox);
exports.CheckboxField = CheckboxField;