"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.HeaderTitle = exports.Dialog = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Typography = require("../Typography");

var _components = require("./components");

var _BaseDialog = require("./BaseDialog");

var _twoLinesClamp = require("../utils/twoLinesClamp");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["width", "header", "controls", "focusDialog", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var HeaderTitle = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'dialog-heading'
}).withConfig({
  displayName: "Dialog__HeaderTitle",
  componentId: "sc-v9vg1z-0"
})(["", ""], _twoLinesClamp.twoLinesClamp);
exports.HeaderTitle = HeaderTitle;

var Dialog = _ref => {
  var {
    width,
    header,
    controls,
    focusDialog = true,
    children
  } = _ref,
      modalProps = _objectWithoutProperties(_ref, _excluded);

  var {
    atTop,
    atBottom,
    scrollRef
  } = (0, _reactHooksShareable.useScrollPosition)();
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_BaseDialog.BaseDialog, _objectSpread(_objectSpread({
    focusDialog: focusDialog,
    width: width,
    verticallyCenter: true
  }, modalProps), {}, {
    children: [header !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseDialog.DialogHeader, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_components.DialogHeaderContent, {
        shadowHidden: atTop !== false,
        children: header
      })
    }) : null, /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseDialog.DialogContent, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_components.DialogMainSection, {
        scrollRef: scrollRef,
        hasHeader: header !== undefined,
        children: children
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_BaseDialog.DialogFooter, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_components.DialogFooterContent, {
        shadowHidden: atBottom !== false,
        children: controls
      })
    })]
  }));
};

exports.Dialog = Dialog;