"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  Expandable: true
};
exports.Expandable = void 0;

var _react = require("react");

var _Transition = require("../Transition");

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _jsxRuntime = require("react/jsx-runtime");

var _ArrowIcon = require("./ArrowIcon");

Object.keys(_ArrowIcon).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _ArrowIcon[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _ArrowIcon[key];
    }
  });
});
var _excluded = ["initialExpanded", "children"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Header = _styledComponents.default.div.withConfig({
  displayName: "Expandable__Header",
  componentId: "sc-1a0ucp6-0"
})(["cursor:pointer;"]);

var ExpandableHeader = _ref => {
  var {
    onClick,
    children
  } = _ref;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(Header, {
    onClick: onClick,
    children: children
  });
};

var Expandable = _ref2 => {
  var {
    initialExpanded = false,
    children
  } = _ref2,
      props = _objectWithoutProperties(_ref2, _excluded);

  var [expanded, setExpanded] = (0, _react.useState)(initialExpanded);
  var toggleExpanded = (0, _react.useCallback)(() => {
    setExpanded(!expanded);
  }, [expanded]);
  var {
    header,
    body
  } = children;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", _objectSpread(_objectSpread({}, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ExpandableHeader, {
      onClick: toggleExpanded,
      children: header(expanded)
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(_Transition.FoldTransition, {
      expanded: expanded,
      children: body
    })]
  }));
};

exports.Expandable = Expandable;