import { HTMLAttributes, FC } from 'react';
import { ExpandableListItemType } from './ExpandableListItem';
export * from './ExpandableListItem';
declare type BaseElement = HTMLDivElement;
declare type BaseProps = HTMLAttributes<BaseElement>;
export interface ExpandableListProps extends BaseProps {
    /**
     * `class` to be passed to the component.
     */
    readonly className?: BaseProps['className'];
    /**
     * Used to create an array of items.
     */
    readonly items: ReadonlyArray<ExpandableListItemType>;
    /**
     * Whether the list should work as accordion
     * and allows only one expanded item at once.
     */
    readonly accordion?: boolean;
}
export declare const ExpandableList: FC<ExpandableListProps>;
