/// <reference types="react" />
import { BaseSelectProps } from './BaseSelect';
import { FieldProps } from '../utils/withField';
export declare const LabelContainer: import("styled-components").StyledComponent<"span", import("styled-components").DefaultTheme, {}, never>;
export declare const PlaceholderContainer: import("styled-components").StyledComponent<"span", import("styled-components").DefaultTheme, {}, never>;
export interface Option<V extends string = string> {
    readonly value: V;
    readonly label: string;
    readonly disabled?: boolean;
}
export interface SelectProps<V extends string = string> extends Omit<BaseSelectProps<V>, 'component' | 'options'> {
    /**
     * Selects an item in the dropdown menu.
     * Must pre-exist in the dropdown menu and written in lowercase.
     * Otherwise no value is selected.
     */
    readonly value: V;
    /**
     * Used to create an array of selectable options.
     */
    readonly options: ReadonlyArray<Option<V>>;
    /**
     * Executes a JavaScript when a user changes the selected option of an element.
     */
    readonly placeholder?: string;
    /**
     * If `true`, select will be disabled.
     */
    readonly disabled?: boolean;
}
export declare function Select<V extends string = string>({ value: currentValue, options, placeholder, ...props }: SelectProps<V>): JSX.Element;
export declare const SelectField: <V extends string = string>(props: FieldProps & SelectProps<V>) => import("react").ReactElement<any, any> | null;
