"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StrengthIndicator = void 0;

var _styledComponents = _interopRequireDefault(require("styled-components"));

var _Typography = require("../Typography");

var _designparams = require("../designparams");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["strength", "helpText"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Get a color that matches the strength level.
 * NOTE: these colors are directly taken from the
 * color palette as they are _not_ theme dependent.
 * Don't do this at home!
 *
 * @param strength The level of strength (between 0 and 1)
 */
var getStrengthColor = (strength, color) => {
  if (strength > 0.75) {
    return color.elementSuccess();
  }

  if (strength > 0.5) {
    return color.elementWarning();
  }

  if (strength > 0) {
    return color.elementError();
  }
};

var PasswordMeterContainer = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordMeterContainer",
  componentId: "sc-3tjdfc-0"
})(["background-color:", ";height:4px;width:240px;overflow:hidden;"], _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background01();
});

var PasswordMeter = _styledComponents.default.div.attrs(_ref2 => {
  var {
    strength
  } = _ref2;
  return {
    style: {
      transform: "scaleX(".concat(strength, ")")
    }
  };
}).withConfig({
  displayName: "StrengthIndicator__PasswordMeter",
  componentId: "sc-3tjdfc-1"
})(["background-color:", ";height:100%;width:100%;transition:transform 0.3s ease-in-out;transform-origin:left center;"], _ref3 => {
  var {
    theme,
    strength
  } = _ref3;
  return getStrengthColor(strength, theme.color);
});

var PasswordWarning = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordWarning",
  componentId: "sc-3tjdfc-2"
})(["overflow:hidden;text-overflow:ellipsis;flex-shrink:1;margin-left:", ";line-height:0;color:", ";"], _designparams.spacing.large, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.text01();
});

var PasswordStrengthIndicator = _styledComponents.default.div.withConfig({
  displayName: "StrengthIndicator__PasswordStrengthIndicator",
  componentId: "sc-3tjdfc-3"
})(["height:16px;width:100%;display:flex;align-items:center;"]);

var StrengthIndicator = _ref5 => {
  var {
    strength,
    helpText
  } = _ref5,
      props = _objectWithoutProperties(_ref5, _excluded);

  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(PasswordStrengthIndicator, _objectSpread(_objectSpread({}, props), {}, {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(PasswordMeterContainer, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(PasswordMeter, {
        strength: strength
      })
    }), /*#__PURE__*/(0, _jsxRuntime.jsx)(PasswordWarning, {
      children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
        variant: "navigation-label",
        children: helpText
      })
    })]
  }));
};

exports.StrengthIndicator = StrengthIndicator;