"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Tooltip = exports.TOOLTIP_DELAY_MS = exports.ExpandedTooltipTypography = exports.ExpandedTooltipAnimation = void 0;

var _react = require("react");

var _styledComponents = _interopRequireWildcard(require("styled-components"));

var _reactHooksShareable = require("react-hooks-shareable");

var _Typography = require("../Typography");

var _PopOver = require("../PopOver");

var _designparams = require("../designparams");

var _theme = require("../theme");

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["children"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * Tooltip
 *
 * A small info shown on hover.
 * Positioned below the anchor element,
 * aligned to it's center.
 */
var TOOLTIP_DELAY_MS = 250;
exports.TOOLTIP_DELAY_MS = TOOLTIP_DELAY_MS;

var BaseTooltipWrapper = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__BaseTooltipWrapper",
  componentId: "sc-uw6km6-0"
})(["display:flex;max-width:280px;border-radius:", ";> *{white-space:pre-line;}"], _designparams.shape.radius.small);

var TooltipWrapper = (0, _styledComponents.default)(BaseTooltipWrapper).withConfig({
  displayName: "Tooltip__TooltipWrapper",
  componentId: "sc-uw6km6-1"
})(["align-items:center;margin:", ";padding:", " ", ";min-height:", ";color:", ";background-color:", ";"], _designparams.spacing.small, _designparams.spacing.small, _designparams.spacing.medium, _designparams.componentSize.mini, _ref => {
  var {
    theme
  } = _ref;
  return theme.color.background00();
}, _ref2 => {
  var {
    theme
  } = _ref2;
  return theme.color.text04();
});
var ExpandedTooltipAnimation = (0, _styledComponents.css)(["animation:fadein 200ms ease-out;@keyframes fadein{from{opacity:0;}to{opacity:1;}}"]);
exports.ExpandedTooltipAnimation = ExpandedTooltipAnimation;
var ExpandedTooltipWrapper = (0, _styledComponents.default)(BaseTooltipWrapper).withConfig({
  displayName: "Tooltip__ExpandedTooltipWrapper",
  componentId: "sc-uw6km6-2"
})(["flex-direction:column;align-items:flex-start;gap:", ";margin:", ";padding:", ";height:auto;color:", ";background-color:", ";box-shadow:", ";word-break:break-word;", ""], _designparams.spacing.medium, _designparams.spacing.medium, _designparams.spacing.medium, _ref3 => {
  var {
    theme
  } = _ref3;
  return theme.color.text01();
}, _ref4 => {
  var {
    theme
  } = _ref4;
  return theme.color.background00();
}, _ref5 => {
  var {
    theme
  } = _ref5;
  return theme.shadow.tooltip;
}, ExpandedTooltipAnimation);

var ExpandedTooltipTop = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__ExpandedTooltipTop",
  componentId: "sc-uw6km6-3"
})(["display:flex;align-items:center;justify-content:space-between;width:100%;white-space:nowrap;gap:", ";"], _designparams.spacing.medium);

var ExpandedTooltipTitle = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Tooltip__ExpandedTooltipTitle",
  componentId: "sc-uw6km6-4"
})(["font-weight:", ";white-space:nowrap;"], _theme.font.fontWeight.semibold);
var ExpandedTooltipExtraInfo = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'compact-label'
}).withConfig({
  displayName: "Tooltip__ExpandedTooltipExtraInfo",
  componentId: "sc-uw6km6-5"
})([""]);
var StyledExpandedTooltipTypography = (0, _styledComponents.default)(_Typography.Typography).attrs({
  variant: 'chip-tag-text'
}).withConfig({
  displayName: "Tooltip__StyledExpandedTooltipTypography",
  componentId: "sc-uw6km6-6"
})(["white-space:normal;"]);

var ExpandedTooltipTypography = _ref6 => {
  var {
    children
  } = _ref6;
  return /*#__PURE__*/(0, _jsxRuntime.jsx)(StyledExpandedTooltipTypography, {
    children: children
  });
};

exports.ExpandedTooltipTypography = ExpandedTooltipTypography;
var upDownArrowBase = (0, _styledComponents.css)(["width:0;height:0;border-left:5px solid transparent;border-right:5px solid transparent;"]);

var TooltipUpArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__TooltipUpArrow",
  componentId: "sc-uw6km6-7"
})(["", ";margin-top:3px;border-bottom:5px solid ", ";"], upDownArrowBase, _ref7 => {
  var {
    theme
  } = _ref7;
  return theme.color.background00();
});

var TooltipDownArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__TooltipDownArrow",
  componentId: "sc-uw6km6-8"
})(["", ";margin-bottom:3px;border-top:5px solid ", ";"], upDownArrowBase, _ref8 => {
  var {
    theme
  } = _ref8;
  return theme.color.background00();
});

var leftRightArrowBase = (0, _styledComponents.css)(["width:0;height:0;border-top:5px solid transparent;border-bottom:5px solid transparent;"]);

var TooltipLeftArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__TooltipLeftArrow",
  componentId: "sc-uw6km6-9"
})(["", ";margin-left:3px;border-right:5px solid ", ";"], leftRightArrowBase, _ref9 => {
  var {
    theme
  } = _ref9;
  return theme.color.background00();
});

var TooltipRightArrow = _styledComponents.default.div.withConfig({
  displayName: "Tooltip__TooltipRightArrow",
  componentId: "sc-uw6km6-10"
})(["", ";margin-right:3px;border-left:5px solid ", ";"], leftRightArrowBase, _ref10 => {
  var {
    theme
  } = _ref10;
  return theme.color.background00();
});

var pointInBounds = pos => pos[0] >= 0 && pos[0] <= document.documentElement.clientWidth && pos[1] >= 0 && pos[1] <= document.documentElement.clientHeight;

var rectInBounds = (pos, size) => pointInBounds(pos) && pointInBounds([pos[0] + size[0], pos[1] + size[1]]);

var alignments = {
  up: {
    horizontalPosition: 'center',
    horizontalAlignment: 'center',
    verticalPosition: 'top',
    verticalAlignment: 'bottom'
  },
  down: {
    horizontalPosition: 'center',
    horizontalAlignment: 'center',
    verticalPosition: 'bottom',
    verticalAlignment: 'top'
  },
  left: {
    horizontalPosition: 'left',
    horizontalAlignment: 'right',
    verticalPosition: 'center',
    verticalAlignment: 'center'
  },
  right: {
    horizontalPosition: 'right',
    horizontalAlignment: 'left',
    verticalPosition: 'center',
    verticalAlignment: 'center'
  }
};
var arrows = {
  left: /*#__PURE__*/(0, _jsxRuntime.jsx)(TooltipRightArrow, {}),
  right: /*#__PURE__*/(0, _jsxRuntime.jsx)(TooltipLeftArrow, {}),
  up: /*#__PURE__*/(0, _jsxRuntime.jsx)(TooltipDownArrow, {}),
  down: /*#__PURE__*/(0, _jsxRuntime.jsx)(TooltipUpArrow, {})
};

var Tooltip = _ref11 => {
  var _ref12;

  var {
    children
  } = _ref11,
      props = _objectWithoutProperties(_ref11, _excluded);

  var placement = (_ref12 = props.variant === 'expanded' ? props.placement : undefined) !== null && _ref12 !== void 0 ? _ref12 : 'up-down';

  var child = _react.Children.only(children);

  var [anchorEl, setAnchorEl] = (0, _react.useState)(null); // State for click

  var [visibleByClick, showByClick] = (0, _react.useState)(false); // Delayed state for pointer

  var [visibleDelayed, showDelayed, hideDelayed] = (0, _reactHooksShareable.useBoolean)(false); // State for pointer

  var [debouncedVisible, setDebouncedVisible] = (0, _react.useState)(false);
  var [layout, setLayout] = (0, _react.useState)('down');
  var [tooltipEl, setTooltipEl] = (0, _react.useState)(null); // If tooltip should be shown

  var visible = visibleByClick || debouncedVisible;
  var toggle = (0, _react.useCallback)(() => {
    // When using touch instead of mouse, we have to toggle the tooltip
    // on "click" instead of "pointerover" and "pointerout"
    showByClick(v => !v);
  }, [showByClick]);
  (0, _react.useEffect)(() => {
    var delayVisible = () => setDebouncedVisible(visibleDelayed);

    var delayed = setTimeout(delayVisible, TOOLTIP_DELAY_MS);
    return () => {
      clearTimeout(delayed);
    };
  }, [visibleDelayed]);
  (0, _react.useLayoutEffect)(() => {
    if (anchorEl === null) {
      return;
    } // Events when using a pointer


    anchorEl.addEventListener('pointerover', showDelayed);
    anchorEl.addEventListener('pointerout', hideDelayed); // Event when using touch

    anchorEl.addEventListener('click', toggle);
    return () => {
      anchorEl.removeEventListener('pointerover', showDelayed);
      anchorEl.removeEventListener('pointerout', hideDelayed);
      anchorEl.removeEventListener('click', toggle);
    };
  }, [anchorEl, hideDelayed, showDelayed, toggle]);
  (0, _react.useLayoutEffect)(() => {
    if (tooltipEl === null || anchorEl === null) {
      return;
    }

    var bounds = anchorEl.getBoundingClientRect(); // "16" is for space of margin of ExpandedTooltipWrapper + arrow size.

    var tooltipSize = [tooltipEl.clientWidth + 16, tooltipEl.clientHeight + 16];
    var tooltipMid = [bounds.left + (bounds.right - bounds.left) / 2, bounds.top + (bounds.bottom - bounds.top) / 2];
    var spaces = {
      down: rectInBounds([tooltipMid[0] - tooltipSize[0] / 2, bounds.bottom], tooltipSize),
      up: rectInBounds([tooltipMid[0] - tooltipSize[0] / 2, bounds.top - tooltipSize[1]], tooltipSize),
      left: rectInBounds([bounds.left - tooltipSize[0], tooltipMid[1] - tooltipSize[1] / 2], tooltipSize),
      right: rectInBounds([bounds.right, tooltipMid[1] - tooltipSize[1] / 2], tooltipSize)
    };

    if (placement === 'up-down') {
      if (spaces.up || spaces.down) {
        setLayout(spaces.down ? 'down' : 'up');
      } else {
        setLayout(spaces.right ? 'right' : 'left');
      }
    } else if (placement === 'left-right') {
      if (spaces.right || spaces.left) {
        setLayout(spaces.right ? 'right' : 'left');
      } else {
        setLayout(spaces.up ? 'up' : 'down');
      }
    }
  }, [anchorEl, tooltipEl, props, placement]);

  if (props.variant !== 'expanded') {
    return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
      children: [/*#__PURE__*/(0, _react.cloneElement)(child, {
        ref: setAnchorEl
      }), visible ? /*#__PURE__*/(0, _jsxRuntime.jsx)(_PopOver.PopOver, _objectSpread(_objectSpread(_objectSpread({
        anchorEl: anchorEl
      }, alignments[layout]), props), {}, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsx)(TooltipWrapper, {
          ref: setTooltipEl,
          children: /*#__PURE__*/(0, _jsxRuntime.jsx)(_Typography.Typography, {
            variant: "chip-tag-text",
            children: props.text
          })
        })
      })) : null]
    });
  }

  var {
    tipTitle,
    extraInfo,
    contents
  } = props;
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
    children: [/*#__PURE__*/(0, _react.cloneElement)(child, {
      ref: setAnchorEl
    }), visible ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(_jsxRuntime.Fragment, {
      children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_PopOver.PopOver, _objectSpread(_objectSpread(_objectSpread({
        anchorEl: anchorEl
      }, alignments[layout]), props), {}, {
        children: /*#__PURE__*/(0, _jsxRuntime.jsxs)(ExpandedTooltipWrapper, {
          ref: setTooltipEl,
          children: [tipTitle !== undefined || extraInfo !== undefined ? extraInfo !== undefined ? /*#__PURE__*/(0, _jsxRuntime.jsxs)(ExpandedTooltipTop, {
            children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(ExpandedTooltipTitle, {
              children: tipTitle
            }), /*#__PURE__*/(0, _jsxRuntime.jsx)(ExpandedTooltipExtraInfo, {
              children: extraInfo
            })]
          }) : /*#__PURE__*/(0, _jsxRuntime.jsx)(ExpandedTooltipTitle, {
            children: tipTitle
          }) : null, contents]
        })
      })), /*#__PURE__*/(0, _jsxRuntime.jsx)(_PopOver.PopOver, _objectSpread(_objectSpread({
        anchorEl: anchorEl
      }, alignments[layout]), {}, {
        children: arrows[layout]
      }))]
    }) : null]
  });
};

exports.Tooltip = Tooltip;